import unidecode
import string
import random
import numpy as np

START = '<s>'
STOP = '</s>'

class SeqData():
    def symbols(self):
        return [START, STOP] + self._symbols

    def random(self):
        return [START] + self._random() + [STOP]

    def validation(self, size=100):
        valid = []
        for i in range(size):
            valid += [self.random()]
        return valid

class ShakesData(SeqData):
    def __init__(self):
        self._symbols = list(string.printable)
        self.file = file = unidecode.unidecode(open('./shakespeare_input.txt').read())
        self.file_len = len(file)
        self.lines = file.split('\n')
        self.paras = file.split('\n\n')
        self.units = self.paras
        print('file_len = {}, {}'.format(len(self.lines), len(self.paras)))

    def _random(self):
        t = random.randint(0, len(self.units))
        return list(self.units[t])

class BalancedData(SeqData):
    def __init__(self):
        self._symbols = ['(', ')']

    def _random(self):
        return list(self.pcfg_min())

    def by_pairs(self, l=10):
        type  = np.random.choice(['extend', 'concat'], p=[0.5, 0.5])
        if l <= 1:
            return '()'
        elif type == 'concat':
            left = random.randint(1, l)
            return self.by_length(left) + self.by_length(l-left)
        else:
            return '(' + self.by_length(l-1) + ')'

    def pcfg_min(self, minl=10):
        d = self.pcfg()
        while len(d) < 10:
            d = self.pcfg()
        return d

    def pcfg(self):
        type  = np.random.choice(['base', 'extend', 'concat'], p=[0.5, 0.3, 0.2])
        if type=='base':
            return '()'
        elif type == 'concat':
            return self.pcfg() + self.pcfg()
        else:
            return '(' + self.pcfg() + ')'

class SimpleBalancedData(SeqData):
    def __init__(self):
        self._symbols =  ['(', ')']

    def _random(self):
        return list(self._balanced())

    def _balanced(self, minl=5, maxl=15):
        l = random.randint(minl, maxl)
        return '(' * l + ')' * l

class GreatData(SeqData):
    # **(5 pts)** generate your own dataset
    def __init__(self):
        self._symbols = []
        # BEGIN_YOUR_CODE (around 1 line of code expected)
        raise Exception("Not implemented yet")
        # END_YOUR_CODE

    def _random(self):
        # BEGIN_YOUR_CODE (around 1 line of code expected)
        raise Exception("Not implemented yet")
        # END_YOUR_CODE
